/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/sferrule.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
surface
sferrule(float Ka=1, Ks=1, roughness=.25;
		color grn=color(0,.125,0), yel=color(1,.46,0))
{
	color cout;
	normal Nf = faceforward(normalize(N), I);
	vector V = normalize(-I);

	if ((v >= .22) && (v <= .24))
	    cout = mix(grn, yel, (v-.22)/.02);
	else if ((v > .24) && (v < .31))
	    cout = yel;
	else if ((v >= .31) && (v <= .33))
	    cout = mix(yel, grn, (v-.31)/.02);
	else if ((v >= .68) && (v <= .70))
	    cout = mix(grn, yel, (v-.68)/.02);
	else if ((v > .70) && (v < .77))
	    cout = yel;
	else if ((v >= .77) && (v <= .79))
	    cout = mix(yel, grn, (v-.77)/.02);
	else
	    cout = grn;

	Oi = Os;
	Ci = Os * cout * (Ka*ambient() + Ks*specular(Nf,V,roughness));
}
