/* $Id: //depot/branches/rmanprod/rat-6.0/ratdocs/education/RenderMan_Companion/tutorial/ch16/shaders/wobble.sl#1 $  (Pixar - RenderMan Division)  $Date: 2004/01/13 $ */
/*
** Copyright (c) 1998 PIXAR.  All rights reserved.  This program or
** documentation contains proprietary confidential information and trade
** secrets of PIXAR.  Reverse engineering of object code is prohibited.
** Use of copyright notice is precautionary and does not imply publication.
**
**                      RESTRICTED RIGHTS NOTICE
**
** Use, duplication, or disclosure by the Government is subject to the
** following restrictions:  For civilian agencies, subparagraphs (a) through
** (d) of the Commercial Computer Software--Restricted Rights clause at
** 52.227-19 of the FAR; and, for units of the Department of Defense, DoD
** Supplement to the FAR, clause 52.227-7013 (c)(1)(ii), Rights in
** Technical Data and Computer Software.
**
** Pixar
** 1001 West Cutting Blvd.
** Richmond, CA  94804
*/
/*
 * wobble shader....
 */

displacement
wobble(float d1 = 0.2;
       float spin = 0.12;
       float d2 = 0.03;)
{
  	varying float dis1, dis2;
	point coord;
	float z;

	z = zcomp(transform("object", P));

	N = normalize(N);
 
	coord = point(s,t, 0);
	dis1 = 0; /*noise(coord);*/
	dis2 = float texture("marks.txt",-s+spin,z-floor(z));

	P = (d1*dis1 - d2*dis2) * N + P;
	N = calculatenormal(P);
}
