#include "hyperManSL.h"
#include "hyperManFuncs.h"
#include "hyperMan_Outputs.h"

light hyperAmbientLight(
    float intensity=1;
    color lightcolor=1;
string lightColorMap = "";
float UselightColorMap = 0;
float lightColorMapPlacement = 0;
float lightColorMapBlur = 0;
)
{
	normal Nf = faceforward( normalize(N), I );

	point STMatrix0 = point "shader" (0,-1,1);
	point STMatrix1 = point "shader" (1,0,0);

	float ss = vector(s, t, 1) . vector(transform("shader", STMatrix0));
	float tt = vector(s, t, 1) . vector(transform("shader", STMatrix1));	
	
	vector Rcurrent = reflect(I, Nf);
	vector Rworld = vtransform("world", Rcurrent);
	
	color colL = 0;

colL = dolightColor(lightColorMap,UselightColorMap, lightColorMapPlacement, lightColorMapBlur, ss, tt,Rworld,colL);
    L  = (0,0,0);
    Cl = intensity * colL;
}
